//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2010, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#property copyright   "Denis Zyatkevich"
#property version     "1.00"
#property description "      "
#property description "   StartHour   EndHour  "
#property description "1      . StopLoss"
#property description "     "
#property description " .    "
#property description "TakeProfit  ,   "
#property description "'indicator_TP', StopLoss   SMA   ,"
#property description "    '' ."

input int    StartHour = 7;
input int    EndHour   = 19;
input int    MAper     = 240;
input double Lots      = 0.1;

int hMA,hCI;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnInit()
  {
   hMA=iMA(NULL,0,MAper,0,MODE_SMA,PRICE_CLOSE);
   hCI=iCustom(NULL,0,"indicator_TP");
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTick()
  {
   MqlTradeRequest request;
   MqlTradeResult result;
   MqlDateTime dt;
   ZeroMemory(request);
   bool bord=false, sord=false;
   int i;
   ulong ticket;
   datetime t[];
   double h[], l[], ma[], atr_h[], atr_l[],
          lev_h, lev_l, StopLoss,
          StopLevel=_Point*SymbolInfoInteger(Symbol(),SYMBOL_TRADE_STOPS_LEVEL),
          Spread   =NormalizeDouble(SymbolInfoDouble(Symbol(),SYMBOL_ASK) - SymbolInfoDouble(Symbol(),SYMBOL_BID),_Digits);
   request.symbol      =Symbol();
   request.volume      =Lots;
   request.tp          =0;
   request.deviation   =0;
   request.type_filling=ORDER_FILLING_FOK;

   TimeCurrent(dt);
   i=(dt.hour+1)*60;
   if(CopyTime(Symbol(),0,0,i,t)<i || CopyHigh(Symbol(),0,0,i,h)<i || CopyLow(Symbol(),0,0,i,l)<i)
     {
      Print("   !");
      return;
     }
   ArraySetAsSeries(t,true);
   ArraySetAsSeries(h,true);
   ArraySetAsSeries(l,true);
   lev_h=h[0];
   lev_l=l[0];
   for(i=1;i<ArraySize(t) && MathFloor(t[i]/86400)==MathFloor(t[0]/86400);i++)
     {
      if(h[i]>lev_h) lev_h=h[i];
      if(l[i]<lev_l) lev_l=l[i];
     }
   lev_h+=Spread+_Point;
   lev_l-=_Point;
   if(CopyBuffer(hMA,0,0,2,ma)<2 || CopyBuffer(hCI,0,0,1,atr_h)<1 || CopyBuffer(hCI,1,0,1,atr_l)<1)
     {
      Print("    !");
      return;
     }
   ArraySetAsSeries(ma,true);
   atr_l[0]+=Spread;

//        
   for(i=0;i<PositionsTotal();i++)
     {
      //     "" 
      if(Symbol()==PositionGetSymbol(i))
        {
         //    StopLoss  TakeProfit
         request.action=TRADE_ACTION_SLTP;
         //   
         if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
           {
            //  StopLoss
            if(ma[1]>PositionGetDouble(POSITION_PRICE_OPEN)) StopLoss=ma[1]; else StopLoss=lev_l;
            //  StopLoss    ,  
            if((PositionGetDouble(POSITION_SL)==0 || NormalizeDouble(StopLoss-PositionGetDouble(POSITION_SL),_Digits)>0
               //  TakeProfit    ,  
               || PositionGetDouble(POSITION_TP)==0 || NormalizeDouble(PositionGetDouble(POSITION_TP)-atr_h[0],_Digits)>0)
               //  StopLoss     ?
               && NormalizeDouble(SymbolInfoDouble(Symbol(),SYMBOL_BID)-StopLoss-StopLevel,_Digits)>0
               //  TakeProfit     ?
               && NormalizeDouble(atr_h[0]-SymbolInfoDouble(Symbol(),SYMBOL_BID)-StopLevel,_Digits)>0)
              {
               //    StopLoss  
               request.sl=NormalizeDouble(StopLoss,_Digits);
               //    TakeProfit  
               request.tp=NormalizeDouble(atr_h[0],_Digits);
               //     
               OrderSend(request,result);
              }
           }
         //   
         if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)
           {
            //   StopLoss
            if(ma[1]+Spread<PositionGetDouble(POSITION_PRICE_OPEN)) StopLoss=ma[1]+Spread; else StopLoss=lev_h;
            //  StopLoss    ,  
            if((PositionGetDouble(POSITION_SL)==0 || NormalizeDouble(PositionGetDouble(POSITION_SL)-StopLoss,_Digits)>0
               //  TakeProfit    ,  
               || PositionGetDouble(POSITION_TP)==0 || NormalizeDouble(atr_l[0]-PositionGetDouble(POSITION_TP),_Digits)>0)
               //  StopLoss     ?
               && NormalizeDouble(StopLoss-SymbolInfoDouble(Symbol(),SYMBOL_ASK)-StopLevel,_Digits)>0
               //  TakeProfit     ?
               && NormalizeDouble(SymbolInfoDouble(Symbol(),SYMBOL_ASK)-atr_l[0]-StopLevel,_Digits)>0)
              {
               //    StopLoss  
               request.sl=NormalizeDouble(StopLoss,_Digits);
               //    TakeProfit  
               request.tp=NormalizeDouble(atr_l[0],_Digits);
               //     
               OrderSend(request,result);
              }
           }
         //     -    ...
         return;
        }
     }
//         
   for(i=0;i<OrdersTotal();i++)
     {
      //    ,   
      ticket=OrderGetTicket(i);
      //     "" 
      if(OrderGetString(ORDER_SYMBOL)==Symbol())
        {
         //   Buy Stop
         if(OrderGetInteger(ORDER_TYPE)==ORDER_TYPE_BUY_STOP)
           {
            //       
            if(dt.hour>=StartHour && dt.hour<EndHour && lev_h<atr_h[0])
              {
               //    ,  
               if((NormalizeDouble(lev_h-OrderGetDouble(ORDER_PRICE_OPEN),_Digits)>0
                  //  StopLoss    ,  
                  || OrderGetDouble(ORDER_SL)==0 || NormalizeDouble(OrderGetDouble(ORDER_SL)-lev_l,_Digits)!=0)
                  //       ?
                  && NormalizeDouble(lev_h-SymbolInfoDouble(Symbol(),SYMBOL_ASK)-StopLevel,_Digits)>0)
                 {
                  //     
                  request.action=TRADE_ACTION_MODIFY;
                  //      
                  request.order=ticket;
                  //       
                  request.price=NormalizeDouble(lev_h,_Digits);
                  //    StopLoss  
                  request.sl=NormalizeDouble(lev_l,_Digits);
                  //     
                  OrderSend(request,result);
                  //    OnTick()
                  return;
                 }
              }
            //          
            else
              {
               //    
               request.action=TRADE_ACTION_REMOVE;
               //     
               request.order=ticket;
               //     
               OrderSend(request,result);
               //    OnTick()
               return;
              }
            //  ,  ,    Buy Stop
            bord=true;
           }
         //   Sell Stop
         if(OrderGetInteger(ORDER_TYPE)==ORDER_TYPE_SELL_STOP)
           {
            //       
            if(dt.hour>=StartHour && dt.hour<EndHour && lev_l>atr_l[0])
              {
               //    ,  
               if((NormalizeDouble(OrderGetDouble(ORDER_PRICE_OPEN)-lev_l,_Digits)>0
                  //  StopLoss    ,  
                  || OrderGetDouble(ORDER_SL)==0 || NormalizeDouble(lev_h-OrderGetDouble(ORDER_SL),_Digits)>0)
                  //       ?
                  && NormalizeDouble(SymbolInfoDouble(Symbol(),SYMBOL_BID)-lev_l-StopLevel,_Digits)>0)
                 {
                  //     
                  request.action=TRADE_ACTION_MODIFY;
                  //      
                  request.order=ticket;
                  //       
                  request.price=NormalizeDouble(lev_l,_Digits);
                  //    StopLoss  
                  request.sl=NormalizeDouble(lev_h,_Digits);
                  //     
                  OrderSend(request,result);
                  //    OnTick()
                  return;
                 }
              }
            //          
            else
              {
               //    
               request.action=TRADE_ACTION_REMOVE;
               //     
               request.order=ticket;
               //     
               OrderSend(request,result);
               //    OnTick()
               return;
              }
            //  ,  ,    Sell Stop
            sord=true;
           }
        }
     }
   request.action=TRADE_ACTION_PENDING;
   if(dt.hour>=StartHour && dt.hour<EndHour)
     {
      if(bord==false && lev_h<atr_h[0])
        {
         request.price=NormalizeDouble(lev_h,_Digits);
         request.sl=NormalizeDouble(lev_l,_Digits);
         request.type=ORDER_TYPE_BUY_STOP;
         OrderSend(request,result);
        }
      if(sord==false && lev_l>atr_l[0])
        {
         request.price=NormalizeDouble(lev_l,_Digits);
         request.sl=NormalizeDouble(lev_h,_Digits);
         request.type=ORDER_TYPE_SELL_STOP;
         OrderSend(request,result);
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   IndicatorRelease(hCI);
   IndicatorRelease(hMA);
  }
//+------------------------------------------------------------------+
